<?php

class IMWB_Covert_Context_content {

   var $content = '';
   var $keywords = array();
   var $currentKeyword = '';
   var $maskLinksList = array();
   var $maskHmlLst = array();
   var $adsProcessed = -1;
   var $currentAdNum = -1;
   
   
   /**
    * The constructor is executed when the class is instatiated and the plugin gets loaded.
    * @return void
    */
   function IMWB_Covert_Context_content($content, $keywords, $adsProcessed) {
      $this->content = $content;
      $this->keywords = $keywords;
      $this->adsProcessed = $adsProcessed;
   }
   
	function maskLinks()	{
	
		if (preg_match_all('/\<a\ .*?\<\/a\>/is', $this->content, $matches))
		{
			if (is_array($matches[0]))
			{
				foreach ($matches[0] as $match)
				{
					$hash = '|'.md5($match).'|';
					$this->maskLinksList[$hash] = $match;
					$this->content = str_replace($match, $hash, $this->content);
				}
			}
		}
	}

	function maskHtml() {
	
		$mask_search = array('h1','h2','h3','h4','h5','h6','strong','b');
		
		foreach ($mask_search as $tag)
		{
			if (preg_match_all('/\<'.$tag.'.*?\<\/'.$tag.'\>/is', $this->content, $matches))
			{
				if (is_array($matches[0]))
				{
					foreach ($matches[0] as $match)
					{
						$hash = '|'.md5($match).'|';
						$this->maskHmlLst[$hash] = $match;
						$this->content = str_replace($match, $hash, $this->content);
					}
				}
			}
		}

		if (preg_match_all('/\<.*?\>/is', $this->content, $matches))
		{
			if (is_array($matches[0]))
			{
				foreach ($matches[0] as $match)
				{
					$hash = '|'.md5($match).'|';
					$this->maskHmlLst[$hash] = $match;
					$this->content = str_replace($match, $hash, $this->content);
				}
			}
		}
	}

	function unmaskHtml() {
	
		if (is_array($this->maskHmlLst))
		{
			foreach ($this->maskHmlLst as $hash => $match)
				$this->content = str_replace($hash, $match, $this->content);
		}
	}

	function unmaskLinks() {
	
		if (is_array($this->maskLinksList))
		{
			foreach ($this->maskLinksList as $hash => $match)
				$this->content = str_replace($hash, $match, $this->content);
		}
	}
	
	function addContextualLinks() {
		if (is_array($this->keywords))
		{
		
//echo "C:".$this->content."C:<br>";		
		   $currentKeywords = $this->keywords; 
		
			foreach ($currentKeywords as $keyword => $ad_num)
			{
//echo "<br>";   
//var_dump($currentKeywords);
//echo "<br>";  			
            if($this->adsProcessed == 0)
               return;
            
            $this->currentKeyword = $keyword;               
            $this->currentAdNum = $ad_num;   

			   $this->content = @preg_replace_callback('/(^|[^a-z])(' . preg_quote(trim($keyword),'/') . ')([^a-z]|$)/is', array($this, 'makeContextualLink'), $this->content,  1);			   
			}
		}
	}

	function makeContextualLink($matches) {
//echo "I:".$this->adsProcessed.":".$matches[2].":".$this->currentKeyword."<br>";

      $link = '<span class="imwb_ccx_keyword" data-ad-num="'.$this->currentAdNum.'">' . $matches[2] . '</span>';
	   $hash = '|'.md5(rand() . $link . serialize($matches)).'|';
		$this->maskHmlLst[$hash] = $link;
		
		$this->adsProcessed-= 1;
		
	   unset($this->keywords[$this->currentKeyword]);   

		return $matches[1].$hash.$matches[3];
	}
	
}