jQuery(document).ready(function($) {

   $('.ajxButton').click(function () {

      var feedCmd = $(this).attr('data-action');
      var feedNum = $(this).attr('data-id');
      var trToDel = $(this).parents('tr');
      var statusCol = $(trToDel).find('td:nth-child(2)');
      var btn = $(this);
      
      if(feedCmd == 'del') {
         if(!confirm('Are you sure you want to delete this ad?'))
            return false;
      }

      var data = {
         action: 'ccx_amazon_options_action',
         dataType: 'html',
         cmd: feedCmd,
         num: feedNum
      };

      $.post(ajaxurl, data, function(response) {
         $('#ajxForm').html(response);
         if(feedCmd == 'del') {
            trToDel.remove();
            return;
         }
         else if(feedCmd == 'pause') {
            btn.attr('data-action', 'activate');
            btn.text('Activate');
            statusCol.text('Paused');
         }
         else if(feedCmd == 'activate') {
            btn.attr('data-action', 'pause');
            btn.text('Pause');
            statusCol.text('Active');            
         }
         
         document.getElementById('ajxForm').scrollIntoView();   
         $('input[name="imwb_covertcontext_ad_options[adname]"]').focus();
      }, 'html');
   
      return false;
   });
   
   $('#contextualAdForm').submit(function() {
   
      if( !$('#adnameimwb_covertcontext_ad_options_adname').val() ) {
         alert('Please Enter a Name');
         $('#adnameimwb_covertcontext_ad_options_adname').focus();
         return false;
      }
      
      if($('#adnameimwb_covertcontext_ad_options_keywords').val() === null) {
         alert('Please enter at least one keyword');
         return false;
      }               
   });
});
