<?php
if(!defined("ABSPATH"))
	die(); // No direct access plx
	
	function array_ikey_exists($key,$arr) 
	{ 
	    if(preg_match("/".$key."/i", join(",", array_keys($arr)), $matches))
	        return $matches[0]; 
	    else 
	        return false; 
	} 
	
if (isset($_POST['import_imwb_covertcontextactive'])) {
   foreach($_POST['import_imwb_covertcontext_active'] as $adNum => $value) {
      $devOptions = get_option($this->plugin_name."-amazon-".$adNum."-AdminOptions");
      $devOptions['active'] = 'Y';
      update_option($this->plugin_name."-amazon-".$adNum."-AdminOptions", $devOptions);
   }
}
?>	
<div class="wrap">
<div id="imwb_plugin_header">
<a href="http://imwealthbuilders.com" target="_blank"><img src="<?php echo $this->plugin_url. '/pages/images/imwblogo.png';?>"></a>
<span id="imwb_plugin_header_link"><a href="http://imwealthbuilders.com/newplugins" target="blank">Click Here To See Our Latest WP Plugins</a></span>
<h2>Covert Context</h2>
<div style="clear: both"></div>
</div>
<?php echo $updateMessage;?>
<div id="imwb_plugin_options_editor">
<div class="icon32" id="icon-link-manager"><br></div><h2>Import Keywords</h2>
<div class="ccx-help-box"><span>This page is used to import the "done for you" Amazon keywords<br> <a href="http://commissionsumo.com/upgrade" target="_blank">Click Here To Grab Your Copy Now!</a></span><br><br>This section allows you to create contextual ads by importing keywords. The name and structure of the import file is important. The name of the file must match the Amazon category the keywords are related to, i.e. electronics.txt. The file must contain the list of keywords/phrases one per line. Please watch the tutorial for help on importing.<div class="help-watch-vid"><a title="Click To Watch A Tutorial Video" href="//www.youtube.com/embed/S5EAMY9aH8c"><img src="<?php echo $this->plugin_url.'/images/wizard-watch-vid.png';?>"></a></div></div>

<?php if (isset($_POST['import_imwb_covertcontextactive'])) { ?>
<div class="ccx-help-box">The status of the imported contextual ad have been updated. <a href="admin.php?page=imwb_covertcontext-admin-menu-amazon">Click Here To View Them</a></div>

<?php } elseif (!isset($_POST['import_imwb_covertcontextfiles'])) { ?>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>" enctype="multipart/form-data">
<table class="widefat">
<tbody style="display: table-row-group;">
<tr>
 <th class="sub-title" scope="col" colspan="2">Import Files</th>
</tr>
<tr valign="top"><td width="400px">Select the files that you wish to import</td>
	<td><input name="importfiles[]" type="file" multiple></td>	  
</tr>
</tbody>
</table>
<div class="submit">
<input class="button-primary" type="submit" name="import_imwb_covertcontextfiles" value="<?php _e('Import Keywords', 'imwb_covertcontext') ?>" />
</div>
</form>
<?php } else { 
   
   $file_post = $_FILES['importfiles'];  
   $file_ary = array();
   $file_count = count($file_post['name']);
   $file_keys = array_keys($file_post);

   for ($i=0; $i<$file_count; $i++) {
      foreach ($file_keys as $key) {
         $file_ary[$i][$key] = $file_post[$key][$i];
      }
   }
   
   $impErrors = Array();
   $adSlots = Array();
   $impAds = Array();
   
// Find available ads slot numbers
   for($feednum = 1; $feednum <= 100; $feednum++) {
      $devOptions = get_option($this->plugin_name."-amazon-".$feednum."-AdminOptions", false);
      if($devOptions === false)
         $adSlots[$feednum] = $feednum;
   } 
   
   foreach ($file_ary as $file) {
      
      $keywords = Array();
   
//      print '<br><br>File Name: ' . $file['name']." ";
//      print 'File tmp_name: ' . $file['tmp_name']." ";
//      print ' File Type: ' . $file['type']." ";
//      print ' File Size: ' . $file['size']." ";
//      print ' File Error: ' . $file['error']." ";
//      print '<br>';
   
      // Check file is ok otherwise add to error array
      if($file['error'] !== UPLOAD_ERR_OK) {
           switch ($file['error']) { 
               case UPLOAD_ERR_INI_SIZE: 
                   $impErrors[$file['name']]["errors"][] = "The uploaded file exceeds the upload_max_filesize directive in php.ini";
                   break; 
               case UPLOAD_ERR_FORM_SIZE: 
                   $impErrors[$file['name']]["errors"][] = "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form"; 
                   break; 
               case UPLOAD_ERR_PARTIAL: 
                   $impErrors[$file['name']]["errors"][] = "The uploaded file was only partially uploaded"; 
                   break; 
               case UPLOAD_ERR_NO_FILE: 
                   $impErrors[$file['name']]["errors"][] = "No file was uploaded"; 
                   break; 
               case UPLOAD_ERR_NO_TMP_DIR: 
                   $impErrors[$file['name']]["errors"][] = "Missing a temporary folder"; 
                   break; 
               case UPLOAD_ERR_CANT_WRITE: 
                   $impErrors[$file['name']]["errors"][] = "Failed to write file to disk"; 
                   break; 
               case UPLOAD_ERR_EXTENSION: 
                   $impErrors[$file['name']]["errors"][] = "File upload stopped by extension"; 
                   break; 
   
               default: 
                   $impErrors[$file['name']]["errors"][] = "Unknown upload error"; 
                   break; 
           } 
      }
      
      // Check file is correct type
      if($file['type'] != 'text/csv' && $file['type'] != 'text/plain' && $file['type'] != 'application/x-csv') {
         $impErrors[$file['name']]["errors"][] = "The file must be either a text or csv file";
         continue;   
      }
   
      // Check Amazon search index exists for the file name other wise report error
      list($filename, $fileext) = split("\.", $file['name'],2);
      $amzSearchIndex = array_ikey_exists($filename,$this->searchIndex_options[$this->options['amzregion']]);
      if($amzSearchIndex === false) {
         $impErrors[$file['name']]["errors"][] = "The Amazon search index cannot be deduced from the file name.";
         continue;
      }      
    
      // Open file
      $handle = @fopen($file['tmp_name'], "r");
      if($handle === false) {
         $impErrors[$file['name']]["errors"][] = "The file cannot be openend";
         continue;
      }
   
      // Read in each keyword
      while (($keyword = fgets($handle)) !== false) {
          $keywords[] = $keyword;
      }
   
      // Close file
      fclose($handle);
   
      // if no keywords then report error
      if(!count($keywords)) {
         $impErrors[$file['name']]["errors"][] = "The file does not contain any keywords";
         continue;      
      }
   
      // Otherwise create ads for the next available add slot
      $adOptions = array('active' => 'N','adname' => $amzSearchIndex.' (imported)','searchindex' => $amzSearchIndex,'minprice' => '','maxprice' => '','allposts' => 'Y','allpages' => 'Y','homeposts' => 'Y','postcats' => '');
      
      $adOptions['keywords'] = implode("",$keywords);
   
      if(count($adSlots)) {
         $adNum = array_shift($adSlots);
   
         // Save the options
         update_option($this->plugin_name."-amazon-".$adNum."-AdminOptions", $adOptions);
         $impAds[$adNum] = $adOptions;
      
      }
      else {
         $impErrors[$file['name']]["errors"][] = "No more ad slots available";
         continue;
      }
   } 
   
if(count($impErrors)) {  
?>	
<div class="ccx-error-box box-padding">
The following files could not be imported due to the errors shown:<br>
<?php 
 foreach($impErrors as $filename => $errors) {
    echo "<br><b>".$filename."</b><br>";
    foreach($errors as $key => $error) {
       echo $error[0]."<br>";
    }
 }
?>
</div>
<?php } 

if(count($impAds)) {  
?>
<div class="ccx-help-box box-padding">
The following contextual ads have been imported and currently set to paused. You can now activate the ones that you would like to use. Please note that we recommend having 2-3 ads active at any one time.<br><br>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>" enctype="multipart/form-data">
<table class="widefat">
<thead>
<tr>
   <th scope="col">Name</th>
   <th scope="col">Keywords</th>
   <th scope="col">Search&nbsp;Index</th>
   <th scope="col">Set Active</th>
</tr>
</thead>
<tbody style="display: table-row-group;">
   
<?php foreach($impAds as $adNum => $adOptions) { ?>
      <tr>
      <td><?php echo stripslashes($adOptions['adname']);?></td>
      <td><textarea id="adnameimwb_covertcontext_ad_options_keywords" name="imwb_covertcontext_ad_options[keywords]" style="width:220px; height: 120px;" readonly><?php echo htmlspecialchars(stripslashes($adOptions['keywords'])) ?></textarea></td>
      <td><?php echo stripslashes($adOptions['searchindex']);?></td>
      <td align="middle"><input  type="checkbox" name="import_imwb_covertcontext_active[<?php echo $adNum; ?>]" value="Y" >
      </td>
      </tr>
<?php  } ?>
</tbody>
</table>
<div class="submit">
<input class="button-primary right" type="submit" name="import_imwb_covertcontextactive" value="<?php _e('Set Selected Ads Active', 'imwb_covertcontext') ?>" />
</div>
</form>
</div>

<?php } } ?>
 </div>
 </div>
 